// directives/zoomMax.js
export default {
  mounted(el, binding) {
    // 指令逻辑
    const domList = [
      {
        dom: `<svg t="1696992086182" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="1588" width="24" height="24"><path d="M752 271H515a8 8 0 0 1-8-8v-64a8 8 0 0 1 8-8h285c17.673 0 32 14.327 32 32v285a8 8 0 0 1-8 8h-64a8 8 0 0 1-8-8V271zM273 751h237a8 8 0 0 1 8 8v64a8 8 0 0 1-8 8H225c-17.673 0-32-14.327-32-32V514a8 8 0 0 1 8-8h64a8 8 0 0 1 8 8v237z" fill="#323338" p-id="1589"></path></svg>`,
        tit: "最大化",
        id: "scale-max",
        hidden: false,
      },
      {
        dom: `<svg t="1696992546139" class="icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="4848" width="24" height="24"><path d="M412.3 544.8c36 0 65.5 27.3 69.1 62.3l0.4 7.1v291c0 10.3-8.4 18.7-18.7 18.7h-46c-10.3 0-18.7-8.4-18.7-18.7V628H120.3c-10.3 0-18.7-8.3-18.7-18.6v-46c0-10.3 8.4-18.7 18.7-18.7h292v0.1zM622.6 121.8V398h281.1c10.3 0 18.7 8.4 18.7 18.7v46c0 10.3-8.4 18.7-18.7 18.7h-295c-36 0-65.5-27.3-69.1-62.3l-0.4-7.1V121.8c0-10.3 8.4-18.7 18.7-18.7h46c10.4 0 18.7 8.4 18.7 18.7z" p-id="4849"></path></svg>`,
        tit: "还原",
        id: "scale-min",
        hidden: true,
      },
    ];

    const {
      el: bindEl = '',
      style = '',
      className = '',
      callBack,
      activeClass = 'show-max',
      restClass = 'show-min',
    } = binding.value || {};

    let wDom = bindEl ? document.querySelector(bindEl) : el;
    wDom.style.position = 'relative';

    const cerateDiv = document.createElement('div');
    domList.forEach((item) => {
      const div = document.createElement('div');
      div.className = 'div-scale';
      div.id = item.id;
      div.hidden = item.hidden;
      div.innerHTML = `<p title="${item.tit}" style="width:30px; top:5px;right:0px; cursor: pointer;position:absolute;z-index:998;${style}">${item.dom}</p>`;
      cerateDiv.prepend(div);

      const sheet = document.styleSheets[0];
      sheet.insertRule(
        `.max-window{width: 100vw!important; height: 100vh !important;margin:0;position:fixed!important;top:0;left:0;z-index:999;background:white}`,
        0
      );

      div.onclick = () => {
        cerateDiv.firstChild.hidden = false;
        cerateDiv.lastChild.hidden = false;
        div.hidden = true;

        if (item.id === 'scale-max') {
          wDom.classList.add('max-window');
          wDom.classList.remove(restClass);
          wDom.classList.add(activeClass);
          callBack && callBack(1);
        } else {
          wDom.classList.remove(activeClass);
          wDom.classList.add(restClass);
          wDom.classList.remove('max-window');
          callBack && callBack(0);
        }
      };
    });

    wDom.prepend(cerateDiv);
  },
};