import './assets/main.css'

import { createApp } from 'vue'
import App from './App.vue'
import router from './router'
import { createPinia } from 'pinia'
import piniaPluginPersistedstate from 'pinia-plugin-persistedstate'

import * as ElementPlusIconsVue from '@element-plus/icons-vue'

import ElementPlus from 'element-plus'
import zhCn from 'element-plus/es/locale/lang/zh-cn'

// Vxe Table 大数据量table优化框架（文档：https://vxetable.cn/#/start/install）
import VxeUI from 'vxe-pc-ui'
import 'vxe-pc-ui/lib/style.css'
import VxeUITable from 'vxe-table'
import 'vxe-table/lib/style.css'
// VxeUITable对element-plus的兼容插件（文档：https://vxeui.com/other4/#/plugin-render-element/install）
import VxeUIPluginRenderElement from '@vxe-ui/plugin-render-element'
import '@vxe-ui/plugin-render-element/dist/style.css'

import useMaxWindowDirective from '@/directives/zoomMax';

const pinia = createPinia()
// pinia数据持久化
pinia.use(piniaPluginPersistedstate)
const app = createApp(App)
for (const [key, component] of Object.entries(ElementPlusIconsVue)) {
  app.component(key, component)
}

// element-plus语言设置
app.use(ElementPlus, {
  locale: zhCn,
})

// 加载VxeUITable对element-plus的兼容插件
VxeUI.use(VxeUIPluginRenderElement)

// 注册自定义指令
app.directive('maxWindow', useMaxWindowDirective);

app.use(VxeUI).use(VxeUITable).use(router).use(pinia).mount('#app')
